/*** usr-guard-cleanup by Mark Wadham - mark.wadham@gmail.com ***/

#include <stdio.h>
#include <time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define LOGFILE		"/var/log/usr-guard.log"
#define BLOCKLIST	"/etc/blocklist"
#define ROUTER_IP	"10.0.0.253"
#define ROUTER_ADMIN	"admin"
#define ROUTER_PASS	"password"
#define BLOCKED_HOURS	3

makedatestr(char *buf,struct tm *tms)
{
	char buf2[4];
	memset(buf,0,16);

	switch(tms->tm_mon)
	{
		case 0: sprintf(buf,"Jan "); break;
		case 1: sprintf(buf,"Feb "); break;
		case 2: sprintf(buf,"Mar "); break;
		case 3: sprintf(buf,"Apr "); break;
		case 4: sprintf(buf,"May "); break;
		case 5: sprintf(buf,"Jun "); break;
		case 6: sprintf(buf,"Jul "); break;
		case 7: sprintf(buf,"Aug "); break;
		case 8: sprintf(buf,"Sep "); break;
		case 9: sprintf(buf,"Oct "); break;
		case 10: sprintf(buf,"Nov "); break;
		case 11: sprintf(buf,"Dec "); break;
	};

	if(tms->tm_mday <10)	sprintf(buf2,"0%d ",tms->tm_mday);
	else			sprintf(buf2,"%d ",tms->tm_mday);
	strcat(buf,buf2);
	if(tms->tm_hour <10)	sprintf(buf2,"0%d:",tms->tm_hour);
	else			sprintf(buf2,"%d:",tms->tm_hour);
	strcat(buf,buf2);
	if(tms->tm_min <10)	sprintf(buf2,"0%d:",tms->tm_min);
	else			sprintf(buf2,"%d:",tms->tm_min);
	strcat(buf,buf2);
	if(tms->tm_sec <10)	sprintf(buf2,"0%d",tms->tm_sec);
	else			sprintf(buf2,"%d",tms->tm_sec);
	strcat(buf,buf2);
}

makelogdate(char *buf)
{
	char lbuf[16];
	char bl[3];
	time_t	thet = time(0);
	struct tm *lt = localtime(&thet);

	if(lt->tm_mday <10)	sprintf(lbuf,"0%d",lt->tm_mday);
	else			sprintf(lbuf,"%d",lt->tm_mday);
	strcat(lbuf,bl);
	if(lt->tm_mon+1 <10)	sprintf(bl,"0%d",lt->tm_mon+1);
	else			sprintf(bl,"%d",lt->tm_mon+1);
	strcat(lbuf,bl);
	if(lt->tm_year-100 <10)	sprintf(bl,"0%d",lt->tm_year-100);
	else			sprintf(bl,"%d",lt->tm_year-100);
	strcat(lbuf,bl);
	if(lt->tm_hour <10)	sprintf(bl,"0%d",lt->tm_hour);
	else			sprintf(bl,"%d",lt->tm_hour);
	strcat(lbuf,bl);
	if(lt->tm_min <10)	sprintf(bl,"0%d",lt->tm_min);
	else			sprintf(bl,"%d",lt->tm_min);
	strcat(lbuf,bl); strcpy(buf,lbuf);
}

logout(char *msg)
{
	FILE *fp;
	struct tm	*thet;
	time_t		timen = time(0);
	thet = localtime(&timen);
	char timebuf[16];

	makedatestr((char *)&timebuf,thet);
	fp = fopen(LOGFILE,"a+");
	fprintf(fp,"%s [cleanup]  %s\n",timebuf,msg);
	fclose(fp);
}

remove_from_blocklist(char *ip)
{
	FILE *fp,*fp2;
	char buf[64];
	char block[1024];
	unsigned int c,x=0;

	if((fp = fopen(BLOCKLIST,"r"))==NULL)
	{
		logout("Error opening blocklist for reading, exiting.");
		exit(0);
	}

	fp2 = fopen("/root/.blocklisttmp","w");

	memset(buf,0,sizeof(buf));
	while((c=getc(fp))!=EOF)
	{
		if(c==10)
		{
			if(strncmp(ip,buf,strlen(ip))!=0)
				fprintf(fp2,"%s\n",buf);
			memset(buf,0,sizeof(buf));x=0;
		}
		else	buf[x++] = c;
	}

	fclose(fp);
	fclose(fp2);

	fp = fopen("/root/.blocklisttmp","r");
	fp2 = fopen(BLOCKLIST,"w");

	while(1)
	{
		c = fread(block,1,1024,fp);
		fwrite(block,1,c,fp2);
		if(c<1024) break;
	}

	fclose(fp);
	fclose(fp2);
	remove("/root/.blocklisttmp");
}

int contains(char *data, char *str, int len)
{
	int i;
	if(len<1) return 0;
	if(strstr(data,str)!=0) return 1;
	return 0;
}

int get_socket(char *ip)
{
        struct sockaddr_in sin;
        int s;
                
        s = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
                        
        sin.sin_addr.s_addr = inet_addr(ip);
        sin.sin_port    =       htons(23);
        sin.sin_family  =       AF_INET;
 
        if((connect(s,(struct sockaddr *)&sin,sizeof(sin))) <0) return -1;
	return s;
}

int send_command(int s, char *cmd)
{
	char packet[1024];
	char cmdbuf[1024];
	char buf[20480];
	unsigned int i,j;

	sprintf(cmdbuf,"%s\n",cmd);
	send(s,cmdbuf,strlen(cmdbuf),0);

	memset(packet,0,sizeof(packet));
	while(1)
	{
		memset(packet,0,sizeof(packet));
		recv(s,packet,sizeof(packet),0);
		if(strcmp(packet,"> ")==0) break;
		if(packet[strlen(packet)-2]=='>' && packet[strlen(packet)-1]==' ') break;
	}
}

int authenticate(int s, char *user, char *pass)
{
	char packet[1024];
	int x=0;

	memset(packet,0,sizeof(packet));
	while((contains(packet,"Login:",x))==0)
	{
		memset(packet,0,sizeof(packet));
		x = recv(s,packet,sizeof(packet),0);
        }

	sprintf(packet,"%s\n",user);
	send(s,packet,strlen(packet),0);

        x=0; memset(packet,0,sizeof(packet));
        while((contains(packet,"Password:",x))==0)
        {
                memset(packet,0,sizeof(packet));
                x = recv(s,packet,sizeof(packet),0);
        }

	sprintf(packet,"%s\n",pass);
        send(s,packet,strlen(packet),0);
 
        while(1)
        {
                memset(packet,0,sizeof(packet));
                recv(s,packet,sizeof(packet),0);

		if(strstr(packet,"incorrect")!=0) return 0;
		if(strcmp(packet,"> ")==0) break;
        }

	return 1;
}

do_unfilter(char *ip)
{
	char cmd[256];
	int s = get_socket(ROUTER_IP);

	if(!authenticate(s,ROUTER_ADMIN,ROUTER_PASS))
	{
		logout("Router authentication failed");
		exit(0);
	}

	sprintf(cmd,"iptables -D INPUT -s %s -j DROP",ip);	send_command(s,cmd);
	sprintf(cmd,"iptables -D FORWARD -s %s -j DROP",ip);	send_command(s,cmd);
}

unfilter(char *ip)
{
	char buf[256];

	remove_from_blocklist(ip);
	sprintf(buf,"Un-filtering %s.",ip); logout(buf);

	if(fork()==0)
	{
		do_unfilter(ip);
		exit(0);
	}
}

unsigned long calc_time(char *datestr)
{
        char day[3],mon[3],yr[3],hr[3],min[3];
        unsigned int i;
        unsigned long timeret = 0;
        struct tm timeval;

        memset(&timeval,0,sizeof(timeval));
        memset(day,0,3);memset(mon,0,3);memset(yr,0,3);memset(hr,0,3);memset(min,0,3);
        memcpy(day,datestr,2);
        memcpy(mon,(char *)&datestr[3],2);
        memcpy(yr,(char *)&datestr[5],2);
        memcpy(hr,(char *)&datestr[7],2);
        memcpy(min,(char *)&datestr[9],2);

        timeval.tm_year = 100+atoi(yr);
        timeval.tm_mon = atoi(mon)-1;
        timeval.tm_mday = atoi(day);
        timeval.tm_hour = atoi(hr);
        timeval.tm_min = atoi(min);

        return mktime(&timeval);
}

extrapolate(char *line, char *ip, char *datestr)
{
	unsigned int i,j;
	memset(ip,0,16); memset(datestr,0,16);

	for(i=0;i<strlen(line);i++)
	{
		if(line[i]==' ') break;
		ip[i] = line[i];
	}
	for(j=i+1;j<strlen(line);j++)
		datestr[j-i-1] = line[j];
}

int ban_time_over(char *datestr)
{
	unsigned long a = time(0), b = calc_time(datestr);
	if((a-b) > BLOCKED_HOURS*60*60) return 1; return 0;
}

process(char *line)
{
	char ip[16], datestr[16];
	extrapolate(line,(char *)&ip,(char *)&datestr);
	if(ban_time_over(datestr)) unfilter(ip);
}

int main(int ac, char *av[])
{
	FILE *fp;
	unsigned int c,x=0;
	char buf[256];

	if((fp = fopen(BLOCKLIST,"r"))==NULL) return 0;

	memset(buf,0,sizeof(buf));
	while((c=getc(fp))!=EOF)
	{
		if(c==10)
		{
			if(strlen(buf)>0) process(buf);
			x=0; memset(buf,0,sizeof(buf));
		}
		else	buf[x++] = c;
	}

	fclose(fp);

	return 0;
}
