/**** usr-guard.c ****/
/**** (c) 2005 by Mark Wadham - mark.wadham@gmail.com ****/

#include <stdio.h>
#include <time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define ALERT_FILE	"/var/log/snort/alert"
#define FRIENDS		"/etc/snort/friends"
#define LOGFILE		"/var/log/usr-guard.log"
#define BLOCKLIST	"/etc/blocklist"
#define ROUTER_IP	"10.0.0.253"
#define ROUTER_ADMIN	"admin"
#define ROUTER_PASS	"password"

char friend[64][16];
unsigned int nf;

read_friends()
{
	FILE *fp;
	unsigned int c,x=0;
	nf = 0;

	for(c=0;c<64;c++) memset(friend[c],0,sizeof(friend[c]));

	if((fp=fopen(FRIENDS,"r"))==NULL)
	{
		logout("Failed to open friends file, exiting.");
		exit(0);
	}

	while((c=getc(fp))!=EOF)
	{
		if(c==10)
		{
			x=0;
			if(inet_addr(friend[nf])!=INADDR_NONE) nf++;
			else memset(friend[nf],0,sizeof(friend[nf]));
		}
		else friend[nf][x++] = c;
	}

	fclose(fp);
}

makedatestr(char *buf,struct tm *tms)
{
	char buf2[4];
	memset(buf,0,16);

	switch(tms->tm_mon)
	{
		case 0: sprintf(buf,"Jan "); break;
		case 1: sprintf(buf,"Feb "); break;
		case 2: sprintf(buf,"Mar "); break;
		case 3: sprintf(buf,"Apr "); break;
		case 4: sprintf(buf,"May "); break;
		case 5: sprintf(buf,"Jun "); break;
		case 6: sprintf(buf,"Jul "); break;
		case 7: sprintf(buf,"Aug "); break;
		case 8: sprintf(buf,"Sep "); break;
		case 9: sprintf(buf,"Oct "); break;
		case 10: sprintf(buf,"Nov "); break;
		case 11: sprintf(buf,"Dec "); break;
	};

	if(tms->tm_mday <10)	sprintf(buf2,"0%d ",tms->tm_mday);
	else			sprintf(buf2,"%d ",tms->tm_mday);
	strcat(buf,buf2);
	if(tms->tm_hour <10)	sprintf(buf2,"0%d:",tms->tm_hour);
	else			sprintf(buf2,"%d:",tms->tm_hour);
	strcat(buf,buf2);
	if(tms->tm_min <10)	sprintf(buf2,"0%d:",tms->tm_min);
	else			sprintf(buf2,"%d:",tms->tm_min);
	strcat(buf,buf2);
	if(tms->tm_sec <10)	sprintf(buf2,"0%d",tms->tm_sec);
	else			sprintf(buf2,"%d",tms->tm_sec);
	strcat(buf,buf2);
}

makelogdate(char *buf)
{
	char lbuf[16];
	char bl[3];
	time_t	thet = time(0);
	struct tm *lt = localtime(&thet);

	if(lt->tm_mday <10)	sprintf(lbuf,"0%d",lt->tm_mday);
	else			sprintf(lbuf,"%d",lt->tm_mday);
	strcat(lbuf,bl);
	if(lt->tm_mon+1 <10)	sprintf(bl,"0%d",lt->tm_mon+1);
	else			sprintf(bl,"%d",lt->tm_mon+1);
	strcat(lbuf,bl);
	if(lt->tm_year-100 <10)	sprintf(bl,"0%d",lt->tm_year-100);
	else			sprintf(bl,"%d",lt->tm_year-100);
	strcat(lbuf,bl);
	if(lt->tm_hour <10)	sprintf(bl,"0%d",lt->tm_hour);
	else			sprintf(bl,"%d",lt->tm_hour);
	strcat(lbuf,bl);
	if(lt->tm_min <10)	sprintf(bl,"0%d",lt->tm_min);
	else			sprintf(bl,"%d",lt->tm_min);
	strcat(lbuf,bl); strcpy(buf,lbuf);
}

logout(char *msg)
{
	FILE *fp;
	struct tm	*thet;
	time_t		timen = time(0);
	thet = localtime(&timen);
	char timebuf[16];

	makedatestr((char *)&timebuf,thet);
	fp = fopen(LOGFILE,"a+");
	fprintf(fp,"%s [guardian] %s\n",timebuf,msg);
	fclose(fp);
}

unsigned long filesize(FILE *stream)
{
        unsigned long curpos, length;

        curpos=ftell(stream);
        fseek(stream,0L,SEEK_END);
        length=ftell(stream);
        fseek(stream,curpos,SEEK_SET);
        return length;
}

unsigned long get_filesize()
{
	FILE *fp;
	unsigned long fs;
	if((fp=fopen(ALERT_FILE,"r"))==NULL)
	{
		logout("Failed to open alert file, exiting.");
		exit(0);
	}
	fs = filesize(fp);
	fclose(fp);
	return fs;
}

get_ip(char *line, unsigned int pos, char *buf)
{
	unsigned int i;
	memset(buf,0,16);
	for(i=pos;i<strlen(line);i++)
	{
		if(line[i]==' ' || line[i]==':') break;
		buf[i-pos] = line[i];
	}
}

unsigned int getpos(char *line, int sel)
{
	unsigned int i,j;
	for(i=0;i<strlen(line);i++)
		if(memcmp((char *)&line[i],"->",2)==0) break;

	if(sel==0)
	{
		for(j=i-2;j>0;j--)
			if(line[j]==' ') break;
		return j+1;
	}

	return i+3;
}

extrapolate(char *line, char *src, char *dst)
{
	get_ip(line,getpos(line,0),src);
	get_ip(line,getpos(line,1),dst);
}

int isfriend(char *ip)
{
	unsigned int i;
	for(i=0;i<nf;i++)
		if(strcmp(ip,friend[i])==0) return 1;
	return 0;
}

int filtered(char *ip)
{
	FILE *fp;
	unsigned int n=0,x=0,c;
	char filt[512][16];

	if((fp = fopen(BLOCKLIST,"r"))==NULL) return 0;

	while((c=getc(fp))!=EOF)
	{
		if(c==' ')
		{
			while((c=getc(fp))!=10) { }
			filt[n][x] = 0;
			x=0; if(inet_addr(filt[n])!=INADDR_NONE) n++;
		}
		else	filt[n][x++] = c;
	}

	fclose(fp);

	for(c=0;c<n;c++)
		if(strcmp(ip,filt[c])==0) return 1;

	return 0;
}

add_to_blocklist(char *ip)
{
	FILE *fp;
	char blockdate[16];

	if((fp = fopen(BLOCKLIST,"a+"))==NULL)
	{
		logout("Error appending to blocklist, exiting.");
		exit(0);
	}

	makelogdate((char *)&blockdate);
	fprintf(fp,"%s %s\n",ip,blockdate);
	fclose(fp);
}

int contains(char *data, char *str, int len)
{
	int i;
	if(len<1) return 0;
	if(strstr(data,str)!=0) return 1;
	return 0;
}

int get_socket(char *ip)
{
        struct sockaddr_in sin;
        int s;
                
        s = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
                        
        sin.sin_addr.s_addr = inet_addr(ip);
        sin.sin_port    =       htons(23);
        sin.sin_family  =       AF_INET;
 
        if((connect(s,(struct sockaddr *)&sin,sizeof(sin))) <0) return -1;
	return s;
}

int send_command(int s, char *cmd)
{
	char packet[1024];
	char cmdbuf[1024];
	char buf[20480];
	unsigned int i,j;

	sprintf(cmdbuf,"%s\n",cmd);
	send(s,cmdbuf,strlen(cmdbuf),0);

	memset(packet,0,sizeof(packet));
	while(1)
	{
		memset(packet,0,sizeof(packet));
		recv(s,packet,sizeof(packet),0);
		if(strcmp(packet,"> ")==0) break;
		if(packet[strlen(packet)-2]=='>' && packet[strlen(packet)-1]==' ') break;
	}
}

int authenticate(int s, char *user, char *pass)
{
	char packet[1024];
	int x=0;

	memset(packet,0,sizeof(packet));
	while((contains(packet,"Login:",x))==0)
	{
		memset(packet,0,sizeof(packet));
		x = recv(s,packet,sizeof(packet),0);
        }

	sprintf(packet,"%s\n",user);
	send(s,packet,strlen(packet),0);

        x=0; memset(packet,0,sizeof(packet));
        while((contains(packet,"Password:",x))==0)
        {
                memset(packet,0,sizeof(packet));
                x = recv(s,packet,sizeof(packet),0);
        }

	sprintf(packet,"%s\n",pass);
        send(s,packet,strlen(packet),0);
 
        while(1)
        {
                memset(packet,0,sizeof(packet));
                recv(s,packet,sizeof(packet),0);

		if(strstr(packet,"incorrect")!=0) return 0;
		if(strcmp(packet,"> ")==0) break;
        }

	return 1;
}

do_filter(char *ip)
{
	char cmd[256];
	int s = get_socket(ROUTER_IP);

	if(!authenticate(s,ROUTER_ADMIN,ROUTER_PASS))
	{
		logout("Router authentication failed");
		exit(0);
	}

	sprintf(cmd,"iptables -I INPUT -s %s -j DROP",ip);	send_command(s,cmd);
	sprintf(cmd,"iptables -I FORWARD -s %s -j DROP",ip);	send_command(s,cmd);
}

filter(char *ip)
{
	char buf[256];

	add_to_blocklist(ip);
	sprintf(buf,"Filtering %s.",ip); logout(buf);

	if(fork()==0)
	{
		do_filter(ip);
		exit(0);
	}
}

process(char *line)
{
	char src[16],dst[16];

	extrapolate(line,(char *)&src,(char *)&dst);

	if(!isfriend(src) && !filtered(src)) filter(src);
	if(!isfriend(dst) && !filtered(dst)) filter(dst);
}

read_difference(unsigned long ptr)
{
	FILE *fp;
	unsigned int c,x=0;
	char buf[1024];

	fp = fopen(ALERT_FILE,"r");
	fseek(fp,ptr,0);

	memset(buf,0,sizeof(buf));
	while((c=getc(fp))!=EOF)
	{
		if(c==10)
		{
			process(buf); x=0;
			memset(buf,0,sizeof(buf));
		}
		else	buf[x++] = c;
	}

	fclose(fp);
}

int main(int ac, char *av[])
{
	char buf[256];
	unsigned long fs,fs2;

	read_friends();

	sprintf(buf,"Guardian v1.1 by Mark Wadham initialised. [%d friends]",nf);
	logout(buf);

	if(fork()!=0) exit(0);

	fs = get_filesize();

	while(1)
	{
		fs2 = get_filesize();
		if(fs != fs2)
		{
			read_difference(fs);
			fs = fs2;
		}
		usleep(20);
	}

	return 0;
}
